-- Feature_cmds.lua
-- Feature Control Routines

--====================================================================
-- this script controls some of the features of the Resurgence maps
-- implementing the clickable buttons which make various components visible
--====================================================================
-- ----------------------------
-- define tables of visibility states
-- ----------------------------
-- return button on mundilfoeri map -> chart map (some c's missing)
-- table of all affected objects
-- this is used to hide them all before drawing the currently visible ones

ft_all = {
"ToOpenControlButton",
"ToOpen2ControlButton",
"ToCloseControlButton",
"ResurgenceClosed",
 "ResurgenceDim",
 "ToDimControlButton",
 "ToBrightControlButton",
"ResurgenceCommOffline",
"ResurgenceReadyF",
"NoAddons",
"CommButton",
"Comm2Button",
"Comm3Button",
"Comm4Button",
"CommInfo",
"CommFail",
"CommInfoSatellite",
"CommInfoWaves",
"HexBackdrop",
"HexControlButton",
"Hex2ControlButton",
"Hex3ControlButton",
"HexInfo",
"ResurgenceNetwork",
"ResurgenceNetwork3D",
"ResurgenceNetwork3D_status",
"ResurgenceNetwork3D_stars",
"ResurgenceNetwork3D_online",
"ResurgenceNetwork3D_offline",
"ResurgenceNetwork3D_down",
"RNet2DButton",
"RNet3DButton",
"RNet2DButtonFilled",
"RNet3DButtonFilled",
"HexBackdrop",
"ResurgenceGraticule",
"Bkg",
"HexField",
"HexButton",
"RedHex_00",
"RedHex_30",
"RedHex_04",
"YelHex_00",
"YelHex_30",
"YelHex_04",
"Repaired_00",
"Repaired_30",
"Repaired_04",
"HexComm",
"HexComm_nopower",
"HexComm_nocom",
"HexComm_nodrive",
"Fusion_active",
"Comm_active",
"Drive_active",
"BuoyID_00",
"BuoyID_30",
"BuoyID_04",
"RNetStarsButton",
"RNetStarsButtonFilled",
"RNetNoStarsButton",
"RNetNoStarsButtonFilled",
"HexBackdrop",
"Hex2ControlButton",
"RNet2DButton",
"RNet2DButtonFilled",
"RNet3DButton",
"RNet3DButtonFilled",
"RNetFusionButton",
"RNetFusionButtonFilled",
"RNetNoFusionButton",
"RNetNoFusionButtonFilled",
"RNetCommButton",
"RNetCommButtonFilled",
"RNetNoCommButton",
"RNetNoCommButtonFilled",
"RNetDriveButton",
"RNetDriveButtonFilled",
"RNetNoDriveButton",
"RNetNoDriveButtonFilled",
"CommPwrOffButton",
"CommPwrOffButtonFilled",
"CommPwrOnButton",
"CommPwrOnButtonFilled",
"LoginOffButton",
"LoginOffButtonFilled",
"LoginOnButton",
"LoginOnButtonDim",
"LoginOnButtonFilled",
"EncrOffButton",
"EncrOffButtonFilled",
"EncrLowButton",
"EncrLowButtonDim",
"EncrLowButtonFilled",
"EncrMedButton",
"EncrMedButtonDim",
"EncrMedButtonFilled",
"EncrHighButton",
"EncrHighButtonDim",
"EncrHighButtonFilled",
"ResurgenceInitializing",
"ResurgenceTestOK1",
"ResurgenceTestOK2",
"ResurgenceTestOK3",
"ResurgenceProgressOK1",
"ResurgenceProgressOK2",
"ResurgenceProgressFail3",
"NS_Map",
"NSSNFlag_f",
"NSLFlag_f",
"NSMFlag_f",
"ReturnButtonF",
"ToChartsButtonF",
}
     
-- HexButton = { fc_show_map, ft_allhex },
ft_allhex = {
"Hex2ControlButton",
"ResurgenceNetwork3D_stars",
"ResurgenceGraticule",
"HexBackdrop",
"HexField",
b00="RedHex_00",
b01="YelHex_30",
b02="YelHex_04",
"RNet2DButton",
"RNet3DButtonFilled",
"RNetStarsButton",
"RNetNoStarsButtonFilled",
"HexButton",
"CommButton",
"ToCloseControlButton",
}


ft_Mundilfoeri = {
"MundilfoeriMap2",
"DropDownButtonM",
"ShowMOrreryButton",
"MuspelionButton",
"JotanisButton",
"AsgariaButton",
"LyosaButton",
"SormorButton",
"NivelionButton",
"MedgariaButton",
"ReturnButtonF",
}

ft_Sola = {
"SolaMap2",
"DropDownButtonS",
"ShowSOrreryButton",
"SyrtButton",
"RanButton",
"HelionButton",
"VainaronButton",
"SvartanButton",
"AEgirButton",
"HymirButton",
}

ft_SuryaNayir = {
"SuryaNayirMap2",
"DropDownButtonSN",
"ShowSNOrreryButton",
"SimhaButton",
"NagaButton",
"KanyaButton",
"MithnaButton",
"AlTaumButton",
"MakaraButton",
"MeenaButton",
"VrisabhaButton",
"KarkaButton",
"KhumbaButton",
}

ft_openit = {
"ToOpen2ControlButton",
"Comm2Button",
"Hex2ControlButton",
"ResurgenceInitializing",
"ResurgenceTestOK1",
}
ft_openit_02 = {
"ToCloseControlButton",
"Comm2Button",
"ResurgenceCommOffline",
"HexControlButton",
}
ft_openit_03 = {
"ToCloseControlButton",
"HexControlButton",
"CommButton",
}
ft_closeit = {
"ToOpenControlButton",
"ResurgenceClosed",
}

ft_comm = {
"CommInfoSatellite",
"CommInfoWaves",
"Comm4Button",
"CommInfo",
"ToCloseControlButton",
"HexControlButton",
"CommPwrOffButton",
"CommPwrOnButtonFilled",
"LoginOffButton",
"LoginOnButtonFilled",
"EncrOffButton",
"EncrLowButton",
"EncrMedButton",
"EncrHighButtonFilled",
"Hex2ControlButton",
}

ft_comm2 = {
"Comm3Button",
"CommFail",
"ToCloseControlButton",
--
"CommPwrOffButtonFilled",
"CommPwrOnButton",
"LoginOffButtonFilled",
"LoginOnButtonDim",
"EncrOffButtonFilled",
"EncrLowButtonDim",
"EncrMedButtonDim",
"EncrHighButtonDim",
"Hex2ControlButton",
}
ft_comm3 = {
"CommInfoSatellite",
"CommInfoWaves",
"Comm4Button",
"CommInfo",
"ToCloseControlButton",
"CommPwrOffButton",
"CommPwrOnButtonFilled",
"LoginOffButton",
"LoginOnButtonFilled",
"EncrOffButton",
"EncrLowButton",
"EncrMedButton",
"EncrHighButtonFilled",
"Hex2ControlButton",
}
ft_comm4 = {
"ToCloseControlButton",
"HexControlButton",
"CommButton",
--"FeatureBackdrop",
"Hex2ControlButton",
}
ft_hex = {
"ResurgenceNetwork",
"Hex2ControlButton",
"RNet3DButton",
"RNet2DButtonFilled",
"CommButton",
"ToCloseControlButton",
}
ft_hex2 = {
"ResurgenceReadyF",
"HexControlButton",
"CommButton",
"ToCloseControlButton",
"ToChartsButtonF"
}
ft_hex3 = {
"ResurgenceReadyF",
"HexControlButton",
"CommButton",
"ToCloseControlButton",
"ToChartsButtonF"
}
ft_hex3D = {
--"ResurgenceNetwork3D",
"ResurgenceNetwork3D_stars",
"Hex2ControlButton",
"RNet2DButton",
"RNet3DButtonFilled",
"ResurgenceGraticule",
"HexBackdrop",
"Bkg",
"HexField",
b00="RedHex_00",
b01="YelHex_30",
b02="YelHex_04",
"HexButton",
"CommButton",
"ToCloseControlButton",
"RNetStarsButtonFilled",
"RNetNoStarsButton",
"BC_MS_",
"Hyperion_1",
"Sola_1",
"Mundilfoeri_1",
"Nayir_1",
"Surya_1",
}

----------------------------------
-- buoy stuff
ft_buoy_names = {
"Buoy_03_00",
"Buoy_00_04",
"Buoy_000-000",
}




ft_buoy00 = {
id = "BuoyID_00",
hex = "HexBackdrop",
btn1=	"ToCloseControlButton",
btn2=	"HexButton",
btn3=	"CommButton",
btn4=	"Hex2ControlButton",
btn5=	"RNet2DButton",
btn6=	"RNet3DButton",
btn7=	"RNetStarsButton",
btn8=	"RNetNoStarsButton",
body =  "HexComm", 
bkg =   "ResurgenceNetwork3D_down",
fusionv = "RC_F",
fusionon =      "RNetFusionButton",
fusionoff =     "RNetNoFusionButtonFilled",
commv = "RC_F",
common =        "RNetCommButton",
commoff =       "RNetNoCommButtonFilled",
drivev = "RC_F",
driveon =       "RNetDriveButton",
driveoff  =     "RNetNoDriveButtonFilled",
}

-- buoy at x=-3,y=0
ft_buoy30 = {
id = "BuoyID_30",
hex = "HexBackdrop",
btn1=	"ToCloseControlButton",
btn2=	"HexButton",
btn3=	"CommButton",
btn4=	"Hex2ControlButton",
btn5=	"RNet2DButton",
btn6=	"RNet3DButton",
btn7=	"RNetStarsButton",
btn8=	"RNetNoStarsButton",
body =  "HexComm", 
bkg = "ResurgenceNetwork3D_offline",
fusionv = "Fusion_active",
fusionon =      "RNetFusionButtonFilled",
fusionoff =     "RNetNoFusionButton",
commv = "RC_F",
common =        "RNetCommButton",
commoff =       "RNetNoCommButtonFilled",
drivev = "Drive_active",
driveon =       "RNetDriveButtonFilled",
driveoff  =     "RNetNoDriveButton",
}

-- buoy at x=0,y=4
ft_buoy04 = {
id = "BuoyID_04",
hex = "HexBackdrop",
btn1=	"ToCloseControlButton",
btn2=	"HexButton",
btn3=	"CommButton",
btn4=	"Hex2ControlButton",
btn5=	"RNet2DButton",
btn6=	"RNet3DButton",
btn7=	"RNetStarsButton",
btn8=	"RNetNoStarsButton",
body =  "HexComm", 
bkg = "ResurgenceNetwork3D_offline",
fusionv = "Fusion_active",
fusionon =      "RNetFusionButtonFilled",
fusionoff =     "RNetNoFusionButton",
commv = "Comm_active",
common =        "RNetCommButtonFilled",
commoff =       "RNetNoCommButton",
drivev = nil,
driveon =       "RNetDriveButton",
driveoff  =     "RNetNoDriveButtonFilled",
}

-- --------------------------------
-- comm buoy status buttons
-- --------------------------------

-- remember which  state for each buoy:
-- fusion = 100
-- comm =   010
-- drive =  001
-- valid states:
-- 000 = all off   = 0 = down
-- 001 = fusion on = 1 = offline
-- 011 = comm on   = 3 = offline
-- 101 = drive on  = 5 = offline
-- 111 = comm & drive on = 7 = online

-- -----------
-- dispay buoy's current state

fc_show_buoy = function (buoytbl)
 fc_hide_tbl(ft_all)
  fc_unmark_buoys()
  fv_neosol_1_visible = 999999999999999999.0

  for j,r in pairs(buoytbl) do fc_show(r) end  
end
-- -----------
fc_show_anon_buoy = function ()
  for j1,r1 in pairs(ft_buoy_locs) do
    if (celestia:find(r1):visible())
    then
      fc_show_buoy(ft_buoy_tables[j1])
      return
    end
  end
end

ft_buoy_locs = {
"BuoyID_00",
"BuoyID_30",
"BuoyID_04",
}
ft_buoy_tables = {
 ft_buoy00,
 ft_buoy30,
 ft_buoy04,
}

ft_offline_buttons = {
comm =  "RNetCommButtonFilled",
drive =  "RNetDriveButtonFilled",
}
-- --------------
fc_set_buoy_value = function (table,element,value)
		    table[element] = value
end

-- --------------
fc_change_buoy = function ()
  local fv_which = 0
  local fv_bstate = 0

  for j1,r1 in pairs(ft_buoy_locs) do
    if (celestia:find(r1):visible())
    then
    fv_which = j1
--fusion power
     if (celestia:find("RNetFusionButtonFilled"):visible())
     then
       fv_bstate = fv_bstate+4
       
--     fc_set_buoy_value (table,element,value)
--       fc_set_buoy_value (ft_buoy_tables[j1],"fusionv", "Fusion_active")
--       fc_set_buoy_value (ft_buoy_tables[j1],"fusionon", "RNetFusionButtonFilled")
--       fc_set_buoy_value (ft_buoy_tables[j1],"fusionoff", "RNetNoFusionButton")

	 if (fv_which == 1)
	 then
	 ft_buoy00.fusionv = "Fusion_active"
	 ft_buoy00.fusionon= "RNetFusionButtonFilled"
	 ft_buoy00.fusionoff= "RNetNoFusionButton"
	 elseif (fv_which == 2)
	 then
	 ft_buoy30.fusionv = "Fusion_active"
	 ft_buoy30.fusionon= "RNetFusionButtonFilled"
	 ft_buoy30.fusionoff= "RNetNoFusionButton"
	 elseif (fv_which == 3)
	 then
	 ft_buoy04.fusionv = "Fusion_active"
	 ft_buoy04.fusionon= "RNetFusionButtonFilled"
	 ft_buoy04.fusionoff= "RNetNoFusionButton"
	 end
     else
--       fc_set_buoy_value (ft_buoy_tables[j1],"fusionv", "RC_F")
--       fc_set_buoy_value (ft_buoy_tables[j1],"fusionon", "RNetFusionButton")
--       fc_set_buoy_value (ft_buoy_tables[j1],"fusionoff", "RNetNoFusionButtonFilled")
	 if (fv_which == 1)
	 then
	 ft_buoy00.fusionv = "RC_F"
	 ft_buoy00.fusionon= "RNetFusionButton"
	 ft_buoy00.fusionoff= "RNetNoFusionButtonFilled"
	 elseif (fv_which == 2)
	 then
	 ft_buoy30.fusionv = "RC_F"
	 ft_buoy30.fusionon= "RNetFusionButton"
	 ft_buoy30.fusionoff= "RNetNoFusionButtonFilled"
	 elseif (fv_which == 3)
	 then
	 ft_buoy04.fusionv = "RC_F"
	 ft_buoy04.fusionon= "RNetFusionButton"
	 ft_buoy04.fusionoff= "RNetNoFusionButtonFilled"
	 end
     end
     
--comm antennae
     if (celestia:find("RNetCommButtonFilled"):visible())
     then
       fv_bstate = fv_bstate+2

	 if (fv_which == 1)
	 then
	 ft_buoy00.commv = "Comm_active"
	 ft_buoy00.common= "RNetCommButtonFilled"
	 ft_buoy00.commoff= "RNetNoCommButton"
	 elseif (fv_which == 2)
	 then
	 ft_buoy30.commv = "Comm_active"
	 ft_buoy30.common= "RNetCommButtonFilled"
	 ft_buoy30.commoff= "RNetNoCommButton"
	 elseif (fv_which == 3)
	 then
	 ft_buoy04.commv = "Comm_active"
	 ft_buoy04.common= "RNetCommButtonFilled"
	 ft_buoy04.commoff= "RNetNoCommButton"
	 end
     else
--       fc_set_buoy_value (ft_buoy_tables[j1],"commv", "RC_F")
--       fc_set_buoy_value (ft_buoy_tables[j1],"common", "RNetCommButton")
--       fc_set_buoy_value (ft_buoy_tables[j1],"commoff", "RNetNoCommButtonFilled")
	 if (fv_which == 1)
	 then
	 ft_buoy00.commv = "RC_F"
	 ft_buoy00.common= "RNetCommButton"
	 ft_buoy00.commoff= "RNetNoCommButtonFilled"
	 elseif (fv_which == 2)
	 then
	 ft_buoy30.commv = "RC_F"
	 ft_buoy30.common= "RNetCommButton"
	 ft_buoy30.commoff= "RNetNoCommButtonFilled"
	 elseif (fv_which == 3)
	 then
	 ft_buoy04.commv = "RC_F"
	 ft_buoy04.common= "RNetCommButton"
	 ft_buoy04.commoff= "RNetNoCommButtonFilled"
	 end
     end
     
--drive power
     if (celestia:find("RNetDriveButtonFilled"):visible())
     then
       fv_bstate = fv_bstate+1

	 if (fv_which == 1)
	 then
	 ft_buoy00.drivev = "Drive_active"
	 ft_buoy00.driveon= "RNetDriveButtonFilled"
	 ft_buoy00.driveoff= "RNetNoDriveButton"
	 elseif (fv_which == 2)
	 then
	 ft_buoy30.drivev = "Drive_active"
	 ft_buoy30.driveon= "RNetDriveButtonFilled"
	 ft_buoy30.driveoff= "RNetNoDriveButton"
	 elseif (fv_which == 3)
	 then
	 ft_buoy04.drivev = "Drive_active"
	 ft_buoy04.driveon= "RNetDriveButtonFilled"
	 ft_buoy04.driveoff= "RNetNoDriveButton"
	 end
     else
--       fc_set_buoy_value (ft_buoy_tables[j1],"drivev", "RC_F")
--       fc_set_buoy_value (ft_buoy_tables[j1],"driveon", "RNetDriveButton")
--       fc_set_buoy_value (ft_buoy_tables[j1],"driveoff", "RNetNoDriveButtonFilled")
	 if (fv_which == 1)
	 then
	 ft_buoy00.drivev = "RC_F"
	 ft_buoy00.driveon= "RNetDriveButton"
	 ft_buoy00.driveoff= "RNetNoDriveButtonFilled"
	 elseif (fv_which == 2)
	 then
	 ft_buoy30.drivev = "RC_F"
	 ft_buoy30.driveon= "RNetDriveButton"
	 ft_buoy30.driveoff= "RNetNoDriveButtonFilled"
	 elseif (fv_which == 3)
	 then
	 ft_buoy04.drivev = "RC_F"
	 ft_buoy04.driveon= "RNetDriveButton"
	 ft_buoy04.driveoff= "RNetNoDriveButtonFilled"
	 end
     end

-- update buoy's 3d icon, too
     fc_bstate(fv_which,fv_bstate)

-- update buoy's background, too
     fc_bbkg(fv_which,fv_bstate)


     fc_show_anon_buoy()

     return
    end
  end


end

-- ---------
-- ft_allhex,ft_hex3D = 
-- b00="RedHex_00",
-- b01="YelHex_30",
-- b02="YelHex_04",
--  local fv_which = 1
-- "Repaired_00",

fc_bstate = function (nbuoy,bstate)
-- do it the hard way

     if (bstate > 6) then 
       if (nbuoy == 1) then
         ft_allhex.b00 = "Repaired_00" 
         ft_hex3D.b00= "Repaired_00" 
       elseif (nbuoy == 2) then
         ft_allhex.b01 = "Repaired_30" 
         ft_hex3D.b01= "Repaired_30" 
       elseif (nbuoy == 3) then
        ft_allhex.b02 = "Repaired_04" 
        ft_hex3D.b02= "Repaired_04" 
       end
     elseif (bstate > 0) then
       if (nbuoy == 1) then
         ft_allhex.b00 = "YelHex_00" 
         ft_hex3D.b00= "YelHex_00" 
       elseif (nbuoy == 2) then
         ft_allhex.b01 = "YelHex_30" 
         ft_hex3D.b01= "YelHex_30" 
       elseif (nbuoy == 3) then
         ft_allhex.b02 = "YelHex_04" 
         ft_hex3D.b02= "YelHex_04" 
       end
     else
       if (nbuoy == 1) then
         ft_allhex.b00 = "RedHex_00" 
         ft_hex3D.b00= "RedHex_00" 
       elseif (nbuoy == 2) then
         ft_allhex.b01 = "RedHex_30" 
         ft_hex3D.b01= "RedHex_30" 
       elseif (nbuoy == 3) then
         ft_allhex.b02 = "RedHex_04" 
         ft_hex3D.b02= "RedHex_04" 
       end
     end
end

-- ------------------
fc_bbkg = function (nbuoy,bstate)
-- do it the hard way

-- ft_buoy00.bkg = "ResurgenceNetwork3D_offline"

     if (bstate > 6) then 
       if (nbuoy == 1) then
         ft_buoy00.bkg = "ResurgenceNetwork3D_online"
       elseif (nbuoy == 2) then
         ft_buoy30.bkg = "ResurgenceNetwork3D_online"
       elseif (nbuoy == 3) then
         ft_buoy04.bkg = "ResurgenceNetwork3D_online"
       end
     elseif (bstate > 0) then
       if (nbuoy == 1) then
         ft_buoy00.bkg = "ResurgenceNetwork3D_offline"
       elseif (nbuoy == 2) then
         ft_buoy30.bkg = "ResurgenceNetwork3D_offline"
       elseif (nbuoy == 3) then
         ft_buoy04.bkg = "ResurgenceNetwork3D_offline"
       end
     else
       if (nbuoy == 1) then
         ft_buoy00.bkg = "ResurgenceNetwork3D_down"
       elseif (nbuoy == 2) then
         ft_buoy30.bkg = "ResurgenceNetwork3D_down"
       elseif (nbuoy == 3) then
         ft_buoy04.bkg = "ResurgenceNetwork3D_down"

       end
     end
end
--===============
-- communications control tables
--===============
ft_pwroffhide = {
"CommPwrOffButton",
"CommPwrOnButtonFilled",
"LoginOffButton",
"LoginOnButton",
"LoginOnButtonFilled",
"EncrOffButton",
"EncrLowButtonFilled",
"EncrMedButtonFilled",
"EncrHighButtonFilled",
"EncrLowButton",
"EncrMedButton",
"EncrHighButton",
"CommInfo",
"CommInfoSatellite",
"CommInfoWaves",
"HexBackdrop",
"HexControlButton",
"Hex3ControlButton",
}
ft_pwroffshow = {
"CommPwrOffButtonFilled",
"CommPwrOnButton",
"LoginOffButtonFilled",
"LoginOnButtonDim",
"EncrOffButtonFilled",
"EncrLowButtonDim",
"EncrMedButtonDim",
"EncrHighButtonDim",
"CommFail",
"Hex2ControlButton",
}
ft_pwronhide = {
"CommPwrOffButtonFilled",
"CommPwrOnButton",
"LoginOnButtonDim",
"EncrLowButtonDim",
"EncrMedButtonDim",
"EncrHighButtonDim",
"LoginOffButton",
"LoginOnButton",
"LoginOnButtonFilled",
"HexBackdrop",
"HexControlButton",
"Hex3ControlButton",
}
ft_pwronshow = {
"CommPwrOffButton",
"CommPwrOnButtonFilled",
"CommInfoSatellite",
"EncrLowButton",
"EncrMedButton",
"EncrHighButton",
"LoginOffButtonFilled",
"LoginOnButtonDim",
"Hex2ControlButton",
}
ft_loginoffhide = {
"LoginOffButton",
"LoginOnButtonFilled",
"CommInfo",
"HexBackdrop",
"HexControlButton",
"Hex3ControlButton",
}
ft_loginoffshow = {
"LoginOffButtonFilled",
"LoginOnButton",
"CommInfoSatellite",
"CommInfoWaves",
"CommFail",
"Hex2ControlButton",
}
ft_loginonhide = {
"LoginOnButton",
"LoginOffButtonFilled",
"CommFail",
"HexBackdrop",
"HexControlButton",
"Hex3ControlButton",
}
ft_loginonshow = {
"LoginOnButtonFilled",
"LoginOffButton",
"CommInfo",
"CommInfoSatellite",
"CommInfoWaves",
"Hex2ControlButton",
}
ft_encroffhide = {
"EncrOffButton",
"EncrLowButtonFilled",
"EncrMedButtonFilled",
"EncrHighButtonFilled",
"LoginOnButtonFilled",
"LoginOnButton",
"LoginOffButton",
"CommInfoWaves",
"CommInfo",
"HexBackdrop",
"HexControlButton",
"Hex3ControlButton",
}
ft_encroffshow = {
"EncrOffButtonFilled",
"EncrLowButton",
"EncrMedButton",
"EncrHighButton",
"LoginOnButtonDim",
"LoginOffButtonFilled",
"CommInfoSatellite",
"CommFail",
"Hex2ControlButton",
}
ft_encrlowhide = {
"EncrOffButtonFilled",
"EncrLowButton",
"EncrMedButtonFilled",
"EncrHighButtonFilled",
"LoginOnButtonDim",
"HexBackdrop",
"HexControlButton",
"Hex3ControlButton",
}
ft_encrlowshow = {
"EncrOffButton",
"EncrLowButtonFilled",
"EncrMedButton",
"EncrHighButton",
"LoginOnButton",
"CommInfoWaves",
"CommInfoSatellite",
"Hex2ControlButton",
}
ft_encrmedhide = {
"EncrOffButtonFilled",
"EncrLowButtonFilled",
"EncrMedButton",
"EncrHighButtonFilled",
"LoginOnButtonDim",
"HexBackdrop",
"HexControlButton",
"Hex3ControlButton",
}
ft_encrmedshow = {
"EncrOffButton",
"EncrLowButton",
"EncrMedButtonFilled",
"EncrHighButton",
"LoginOnButton",
"CommInfoWaves",
"CommInfoSatellite",
"Hex2ControlButton",
}
ft_encrhighhide = {
"EncrOffButtonFilled",
"EncrLowButtonFilled",
"EncrMedButtonFilled",
"EncrHighButton",
"LoginOnButtonDim",
"HexBackdrop",
"HexControlButton",
"Hex3ControlButton",
}
ft_encrhighshow = {
"EncrOffButton",
"EncrLowButton",
"EncrMedButton",
"EncrHighButtonFilled",
"LoginOnButton",
"CommInfoWaves",
"CommInfoSatellite",
"Hex2ControlButton",
}

-- ----------------------------
-- determine whether or not the addons
-- that this script knows how to cooperate with
-- were detected when this addon initialized
-- ----------------------------

ft_coop = {
  fv_zeus = false,
  fv_resurgence = false,
  fv_mundilfoeri = false,
  fv_surya_nayir = false,
  fv_sola = false,
}
fv_coop = false

-- ----------------------------
-- functions to hide and show the objects
-- ----------------------------
fc_mark_buoys = function ()
  local ft_rf = { markers = true }
  celestia:setrenderflags (ft_rf)
  
  for j,r in pairs(ft_buoy_names) do
    celestia:find(r):mark("white", "plus", 20.0, 1, r,false)
  end -- for j,r loop

end
fc_unmark_buoys = function ()
  local ft_rf = { markers = false }
  celestia:setrenderflags (ft_rf)
  for j,r in pairs(ft_buoy_names) do
    celestia:unmark(celestia:find(r))
  end -- for j,r loop
end

-- ---------------

ft_stars = {
"Surya_1",
"Nayir_1",
"Mundilfoeri_1",
 "Sola_1",
 "Hyperion_1",
}
ft_star_names = {
"Surya",
"Nayir",
"Mundilfoeri",
 "Sola",
 "Hyperion",
}

fc_mark_orrery_stars = function ()
  ft_rf = { markers = true }
  celestia:setrenderflags (ft_rf)
  
  for j,r in pairs(ft_stars) do
    celestia:find(r):mark("black", "circle", 20.0, 1, r,false)
  end -- for j,r loop

end


fc_unmark_orrery_stars = function ()
--  ft_rf = { markers = true }
--  celestia:setrenderflags (ft_rf)
  
  for j,r in pairs(ft_stars) do
    celestia:unmark(celestia:find(r))
  end -- for j,r loop

end



-- ---------------
fc_show = function (name)
   celestia:find(name):setvisible(true)
end
-- ---------------
fc_hide = function (name)
   celestia:find(name):setvisible(false)
end
-- ---------------
fc_brightenit = function ()
  fc_hide("ResurgenceDim")
  fc_hide("ToBrightControlButton")
  fc_show("ToDimControlButton")
end

fc_dimit = function ()
  fc_show("ResurgenceDim")
  fc_show("ToBrightControlButton")
  fc_hide("ToDimControlButton")
end
-- ---------------

fc_show_tbl = function (map_table)
  for j,r in pairs(map_table) do
    fc_show(r)
  end -- for j,r loop
end
-- ---------------
fc_hide_tbl = function (map_table)
  for j,r in pairs(map_table) do
   celestia:find(r):setvisible(false)
  end -- for j,r loop
end

-- ----------------
fc_hide_others = function ()
-- hides maps of other resurgence addons

   if (ft_coop.fv_resurgence)
   then
     fc_hide_tbl(rmt_all) -- resurgence + hyperion
   end

   if (ft_coop.fv_mundilfoeri)
   then
    fc_hide_tbl (mt_all) -- mundilfoeri addon
    fc_hide("Mundilfoeri_")
   end

   if (ft_coop.fv_surya_nayir)
   then
     fc_hide_tbl (snt_all) -- surya/nayir
   end

  if (ft_coop.fv_sola)
   then
    fc_hide_tbl (st_all) -- sola
    fc_hide("Sola_")
   end

  if (ft_coop.fv_zeus)
   then
    fc_hide_tbl (bt_all) -- zeus battery
    fc_hide("NavigOffline")
   end
end
-- ----------------
ft_buttons = {
"HexControlButton",
"CommButton",
"ToCloseControlButton",
}

fc_show_buttons = function()
-- ensure correct bright/dim function is available
  if (celestia:find("ResurgenceDim"):visible())
   then fc_dimit()
   else fc_brightenit()
  end

  fc_show_tbl (ft_buttons)

end
-- ----------------

fc_show_maplinks = function (link)
-- shows links to maps of other resurgence addons, if possible

   if (not fv_coop)
   then
     fc_show_map({"NoAddons"})
     fc_show_buttons()
     return
   end

   if (ft_coop.fv_resurgence)
   then
     fc_show_map (rmt_galaxy_nolbl) -- resurgence/hyperion addon
     return
   end

   local fv_flags = false
   
   fc_show_map({"NS_Map"})

   if (ft_coop.fv_surya_nayir)
   then
     fc_show ("NSSNFlag_f")
     fv_flags = true
   end
   if (ft_coop.fv_sola)
   then
     fc_show ("NSLFlag_f")
     fv_flags = true
   end
   if (ft_coop.fv_mundilfoeri)
   then
     fc_show ("NSMFlag_f")
     fv_flags = true
   end

   if ( (not fv_flags) and ft_coop.fv_zeus)
   then
--     fc_show_map({"NavigOffline"})
   end

   fc_show_buttons()
end

-- --------------------
fc_show_map = function (map_table)
  fc_hide_tbl(ft_all)
  fc_hide_others()
  fv_neosol_1_visible = 999999999999999999.0
  fc_show_tbl (map_table)
  fc_unmark_orrery_stars()
  fc_hide("Mundilfoeri_")
  fc_unmark_buoys()
end

fc_show_bmap = function (map_table)
  fc_hide_tbl(ft_all)
  fc_hide_others()
  fv_neosol_1_visible = 999999999999999999.0
  fc_show_tbl (map_table)
  fc_unmark_orrery_stars()
  fc_hide("Mundilfoeri_")
  fc_unmark_buoys()
end


fc_show_maps = function (map_table)
  fc_hide_tbl(ft_all)
  fc_show_others()
  fv_neosol_1_visible = 999999999999999999.0
  fc_show_tbl (map_table)
  fc_unmark_orrery_stars()
  fc_hide("Mundilfoeri_")
  fc_unmark_buoys()
end

-- --------------
fc_show_others = function ()
-- shows maps of other resurgence addons, if possible

-- if showing others, then comms aren't offline
   fc_hide("ResurgenceCommOffline")
--   fc_hide("ResurgenceReadyF")

   if (false)
   then
     fc_show_map({"MundilfoeriMap2"})
--     fc_show_map(mt_Mundilfoeri)
--       mcm_show_map()
--     fc_show_buttons()
--     fc_show("ReturnButtonF")
     return
   end

   if (ft_coop.fv_resurgence)
   then
     fc_show_map (rmt_galaxy_nolbl) -- resurgence/hyperion addon

   elseif (fv_coop)
   then
     fc_show_maplinks()
   else
     fc_show_map({"NoAddons"})
   end

  fc_show_buttons()
end
-- --------------------

fc_show_other_map= function (map)
     fc_show_map({map})
     fc_show_buttons()
end

fc_show_other_mapt= function (map)
     fc_hide("NS_Map")

if (false) then
--     fc_hide("NSSNFlag_f")
--     fc_hide("NSLFlag_f")
--     fc_hide("NSMFlag_f")
     fc_show_tbl(map)

     fc_show_buttons()
     if ((map == ft_Sola) or (map == ft_Mundilfoeri) or (map == ft_SuryaNayir))
     then
       fc_show("ReturnButtonF")
     end
end
end


-- =============================================
-- ensure orrery stars aren't visible at start
  fv_neosol_1_visible = 999999999999999999.0

-- NeoSolOrrerytimeButton = {fc_show_orrery,ft_hex},

fc_show_orrery = function ()
  fc_show_map(ft_hex3D)
  fv_neosol_1_visible = 0.0
  fc_mark_orrery_stars()
  fc_mark_buoys()
  
  if (ft_coop.fv_zeus)
   then
    fc_hide("NavigOffline")
   end

  end

fc_hide_orrery = function ()
  fc_show_map(ft_allhex)
  fv_neosol_1_visible = 999999999999999999.0
  fc_unmark_orrery_stars()
  fc_mark_buoys()

  if (ft_coop.fv_zeus)
   then
    fc_hide("NavigOffline")
   end

  end


--====================================================================
-- command routines
--====================================================================

fc_initialize = function ()
  fc_show_map(ft_openit)
  fv_iT0 = 86400.0*celestia:gettime()

  if (ft_coop.fv_zeus)
  then
    fc_show_tbl (bt_battery)
-- and try to show the corresponding charge value in small image
    fc_show(bt_charge[bv_j])
  end
end

-- count number of times the "cmds" scripted orbit has been called

fv_ninit = 0

-- do different initializations each of the first few times
--  scripted orbit has run

fc_init = function ()
  if (fv_ninit > 7) then return end
  fv_ninit=fv_ninit+1

-- do nothing the first time:
-- wait until other addons are guaranteed to have been loaded
  if (fv_ninit < 2) then return end

  if (fv_ninit == 2)
  then
-- initialize comm waves
    fv_wT0 = 86400.0*celestia:gettime()
    fv_wR2 = celestia:find("CommInfoWaves"):radius()
    fv_wR1 = fv_wR2/2.0

-- everything is turned off: show large box that hides everything
    fc_show_map(ft_closeit)

-- detect presence of other addons
-- each is done individually at a different time in case of an abnormal exit

-- resurgence
   if (celestia:find("Maps"):type() == 'component')
    then
      ft_coop.fv_resurgence = true
      fv_coop = true
      fc_hide_tbl(rmt_all) -- resurgence + hyperion
      fc_show_map(ft_closeit)
      return
    end
  elseif (fv_ninit == 3)
  then
-- zeus battery
    if (celestia:find("Maps_B"):type() == 'component')
    then
      ft_coop.fv_zeus = true
      fc_hide_tbl (bt_all) -- zeus battery
      fc_hide("NavigOffline")
      fc_show("BatteryControlButton")
      fc_show_map(ft_closeit)
    return
    end
  elseif (fv_ninit == 4)
  then
-- mundilfoeri
   if (celestia:find("Maps_M"):type() == 'component')
    then
      ft_coop.fv_mundilfoeri = true
      fv_coop = true
      fc_hide_tbl (mt_all) -- mundilfoeri addon
      fc_show_map(ft_closeit)
      return
    end
  elseif (fv_ninit == 5)
  then
-- sola
   if (celestia:find("Maps_S"):type() == 'component')
    then
      ft_coop.fv_sola = true
      fv_coop = true
      fc_hide_tbl (st_all) -- sola
      fc_show_map(ft_closeit)
      return
    end
  elseif (fv_ninit == 6)
  then
-- surya-nayir
   if (celestia:find("Maps_SN"):type() == 'component')
    then
      ft_coop.fv_surya_nayir = true
      fv_coop = true
      fc_hide_tbl (snt_all) -- surya/nayir
      fc_show_map(ft_closeit)
      return
    end
  elseif (fv_ninit == 7)
  then
      fc_hide_others()
      fc_show_map(ft_closeit)
      return
   end
end


---------------------------------------
-- RNetCommButton = {fc_show_comm,nil},
ft_hidesc = {
"RNetCommButton",
"RNetNoCommButtonFilled",
}
ft_showsc = {
"RNetNoCommButton",
"RNetCommButtonFilled",
"Comm_active",
}



fc_show_comm = function ()
    if (celestia:find("Fusion_active"):visible())
    then 
      fc_hide_tbl(ft_hidesc)
      fc_show_tbl(ft_showsc)
      if (celestia:find("RNetDriveButtonFilled"):visible())
      then
	fc_show("ResurgenceNetwork3D_online")
	fc_hide("ResurgenceNetwork3D_offline")
	fc_change_buoy()
      else
	fc_hide("ResurgenceNetwork3D_online")
	fc_show("ResurgenceNetwork3D_offline")
	fc_change_buoy()
      end
    end
end

-- RNetNoCommButton = {fc_show_nocomm,nil},
fc_show_nocomm = function ()
  fc_show_tbl(ft_hidesc)
  fc_hide_tbl(ft_showsc)
  fc_hide("ResurgenceNetwork3D_online")
  fc_show("ResurgenceNetwork3D_offline")
  fc_change_buoy()
end
----------
ft_hidesfon = {
"ResurgenceNetwork3D_online",
"ResurgenceNetwork3D_down",
"RNetFusionButton",
"RNetNoFusionButtonFilled",
}
ft_showsfon = {
"ResurgenceNetwork3D_offline",
"RNetNoFusionButton",
"RNetFusionButtonFilled",
"Fusion_active",
}

-- RNetFusionButton = {fc_show_fusion,nil},
fc_show_fusion = function ()
  fc_hide_tbl(ft_hidesfon)
  fc_show_tbl(ft_showsfon)
  fc_change_buoy()
end

ft_hidesfoff = {
"ResurgenceNetwork3D_online",
"ResurgenceNetwork3D_offline",
"RNetNoFusionButton",
"RNetFusionButtonFilled",
"Fusion_active",
"RNetNoCommButton",
"RNetCommButtonFilled",
"Comm_active",
"RNetNoDriveButton",
"RNetDriveButtonFilled",
"Drive_active",
}
ft_showsfoff = {
"ResurgenceNetwork3D_down",
"RNetFusionButton",
"RNetNoFusionButtonFilled",
"RNetDriveButton",
"RNetNoDriveButtonFilled",
"RNetCommButton",
"RNetNoCommButtonFilled",
}
-- RNetNoFusionButton = {fc_show_nofusion,nil},
fc_show_nofusion = function ()
  fc_show_tbl(ft_showsfoff)
  fc_hide_tbl(ft_hidesfoff)
  fc_change_buoy()
end
----------
ft_hidesd = {
"RNetDriveButton",
"RNetNoDriveButtonFilled",
}
ft_showsd = {
"RNetNoDriveButton",
"RNetDriveButtonFilled",
"Drive_active",
}

-- RNetDriveButton = {fc_show_drive,nil},
fc_show_drive = function ()
    if (celestia:find("Fusion_active"):visible())
    then 
      fc_hide_tbl(ft_hidesd)
      fc_show_tbl(ft_showsd)
      if (celestia:find("RNetCommButtonFilled"):visible())
      then
	fc_show("ResurgenceNetwork3D_online")
	fc_hide("ResurgenceNetwork3D_offline")
  	fc_change_buoy()
    else
	fc_hide("ResurgenceNetwork3D_online")
	fc_show("ResurgenceNetwork3D_offline")
	fc_change_buoy()
      end
    end
end

-- RNetNoDriveButton = {fc_show_nodrive,nil},
fc_show_nodrive = function ()
  fc_show_tbl(ft_hidesd)
  fc_hide_tbl(ft_showsd)
  fc_hide("ResurgenceNetwork3D_online")
  fc_show("ResurgenceNetwork3D_offline")
  fc_change_buoy()
end

-- --------------------------------
-- orrery
-- --------------------------------
fc_test_for_orrery = function()
-- multiple orreries cause celestia to crash :(
  local obj
    obj =celestia:find("GotoSysButton")
    if (obj:visible()) then obj:setvisible(false) ; return end

    obj =celestia:find("ShowMOrreryButton")
    if (obj:visible()) then obj:setvisible(false) ; return  end

    obj =celestia:find("ShowSOrreryButton")
    if (obj:visible())    then obj:setvisible(false) ; return end

    obj =celestia:find("ShowSNOrreryButton")
    if (obj:visible())    then obj:setvisible(false) ; return end
end

ft_neosol = {
"GalaxyButton",
"GalaxyMapButton3",
"NeosolButton",
"NSOButton",
"NSSuryaButton",
"NSNayirButton",
"NSMundilfoeriButton",
"NSSolaButton",
"NSHyperionButton",
}

ft_nsmap = {
"NS_Map",
"ResurgenceReadyF",
"NSSNFlag_f",
"NSLFlag_f",
"NSMFlag_f",
}

-- show appropriate buttons on "other" maps
-- and hide some maps, too
fc_test_for_buttons = function()

   if (not (celestia:find("SolaMap2"):visible() or celestia:find("MundilfoeriMap2"):visible() or celestia:find("SuryaNayirMap2"):visible()))
   then
     fc_hide("ReturnButtonF")
   else
     fc_show("ReturnButtonF")
     fc_hide_tbl(ft_nsmap)
   end

    if (celestia:find("GalaxyMap_nolbl"):visible()) 
    then
      fc_hide_tbl(ft_neosol)
      fc_hide_tbl(ft_all)
      fc_show_tbl(ft_openit_03)
    end

-- ??? zeus should be doing this but it doesn't

  if (ft_coop.fv_zeus)
  then
    fc_show_tbl (bt_battery)
-- and try to show the corresponding charge value in small image
    fc_show(bt_charge[bv_j])

    if (celestia:find("BatteryInst"):visible())
    then
      fc_hide("CommInfoSatellite")
      fc_hide("CommInfoWaves")
    elseif (celestia:find("CommInfo"):visible())
    then
      fc_show("CommInfoSatellite")
      fc_show("CommInfoWaves")
    end
  end

  

-- ensure bright/dim function is available
  if (celestia:find("ResurgenceDim"):visible())
  then fc_dimit()
  else fc_brightenit()
  end

end
--=====
-- ------- progress bar -------------

fc_cycle_init = function ()
  if ( celestia:find("ResurgenceTestOK1"):visible()) then
    local fv_iTd = 86400.0*celestia:gettime()
    local dt = fv_iTd -fv_iT0
    if (dt > 1.5)
    then
      fv_iT0 = fv_iTd
      celestia:find("ResurgenceTestOK1"):setvisible(false)
      celestia:find("ResurgenceProgressOK1"):setvisible(true)
      celestia:find("ResurgenceTestOK2"):setvisible(true)
    end
  elseif ( celestia:find("ResurgenceTestOK2"):visible()) then
    local fv_iTd = 86400.0*celestia:gettime()
    local dt = fv_iTd -fv_iT0
    if (dt > 1.5)
    then
      fv_iT0 = fv_iTd
      celestia:find("ResurgenceTestOK2"):setvisible(false)
      celestia:find("ResurgenceProgressOK2"):setvisible(true)
      celestia:find("ResurgenceTestOK3"):setvisible(true)
    end
  elseif ( celestia:find("ResurgenceTestOK3"):visible()) then
    local fv_iTd = 86400.0*celestia:gettime()
    local dt = fv_iTd -fv_iT0
    if (dt > 1.5)
    then
      fv_iT0 = fv_iTd
      celestia:find("ResurgenceTestOK3"):setvisible(false)
      celestia:find("ResurgenceProgressFail3"):setvisible(true)
    end
  elseif ( celestia:find("ResurgenceProgressFail3"):visible()) then
    local fv_iTd = 86400.0*celestia:gettime()
    local dt = fv_iTd -fv_iT0
    if (dt > 1.5)
    then
      fv_iT0 = fv_iTd
      fc_show_map(ft_openit_02)

  if (ft_coop.fv_zeus)
  then
    fc_show_tbl (bt_battery)
-- and try to show the corresponding charge value in small image
    fc_show(bt_charge[bv_j])
  end

    end
  end

end
-- -------comm radiation --------
fc_cycle_waves = function ()
  local obj = celestia:find("CommInfoWaves")
  if ( obj:visible()) then
    local fv_wTd = 86400.0*celestia:gettime()
    local dt = fv_wTd -fv_wT0
    if (dt > 1.0 or dt < 0.0)
    then
      dt = 0.0
      fv_wT0 = fv_wTd
    end
    obj:setradius(fv_wR1 + (fv_wR2-fv_wR1)*dt)
  end
end
-- --------- comm buttons --------
fc_pwroff = function ()
  fc_hide_tbl(ft_pwroffhide)
  fc_show_tbl(ft_pwroffshow)
end
fc_pwron = function ()
    fc_hide_tbl(ft_pwronhide)
    fc_show_tbl(ft_pwronshow)
end

fc_loginoff = function ()
  fc_hide_tbl(ft_loginoffhide)
  fc_show_tbl(ft_loginoffshow)
end

fc_loginon = function ()
    fc_show_map(ft_comm3)
end
fc_encroff = function ()
  fc_hide_tbl(ft_encroffhide)
  fc_show_tbl(ft_encroffshow)
end
fc_encrlow = function ()
  if ( celestia:find("CommPwrOnButtonFilled"):visible()) then
    fc_hide_tbl(ft_encrlowhide)
    fc_show_tbl(ft_encrlowshow)
  end
end
fc_encrmed = function ()
  if ( celestia:find("CommPwrOnButtonFilled"):visible()) then
    fc_hide_tbl(ft_encrmedhide)
    fc_show_tbl(ft_encrmedshow)
  end
end
fc_encrhigh = function ()
  if ( celestia:find("CommPwrOnButtonFilled"):visible()) then
    fc_hide_tbl(ft_encrhighhide)
    fc_show_tbl(ft_encrhighshow)
  end
end


--====================================================================
-- command processor table and routines:
-- the name of the selected object is interpreted as a command
--====================================================================

-- fv_selP = previous selection
-- to be restored immediately after recognizing a command
-- assume initial selection (if any) when Celestia starts isn't a command

-- must be initialized
-- but can't use getselection during startup of Celestia
-- which is when this code is initially executed
-- because nothing has been selected yet

fv_selP = nil

-- ======================================= 
-- table of commands:
-- command text (i.e.name of selected object) = { command function, arg_of_fn },

ft_cmds = {
 ToCloseControlButton = {fc_show_map,ft_closeit},
 ToOpenControlButton = {fc_initialize,nil},
-- ToOpenControlButton = {fc_show_map,ft_openit},
 ToOpen2ControlButton = {fc_show_map,ft_openit_02},
 ToDimControlButton = {fc_dimit,nil},
 ToBrightControlButton = {fc_brightenit,nil},
 CommButton = {fc_show_map,ft_comm},
 Comm2Button = {fc_show_map,ft_comm2},
 Comm3Button = {fc_show_map,ft_comm3},
 Comm4Button = {fc_show_maps,ft_comm4},
-- Comm4Button = {fc_show_others,nil},
 ResurgenceInitializing = {fc_show_map,ft_openit_02},
-- comm interaction
CommPwrOffButton = { fc_pwroff,nil},
CommPwrOnButton = { fc_pwron,nil},
LoginOffButton = { fc_loginoff,nil},
LoginOnButton = { fc_loginon,nil},
EncrOffButton = { fc_encroff,nil},
EncrLowButton = { fc_encrlow,nil},
EncrMedButton = { fc_encrmed,nil},
EncrHighButton = { fc_encrhigh,nil},
-- network interaction
ResurgenceNetwork = {fc_show_orrery,nil},
HexControlButton = {fc_show_map,ft_hex},
Hex2ControlButton = {fc_show_maps,ft_hex2},
-- Hex3ControlButton = {fc_show_others,nil},
Hex3ControlButton = {fc_show_map,ft_hex3},
RNet2DButton = {fc_show_bmap,ft_hex},
RNet3DButton = {fc_show_orrery,nil},
--
RedHex_00 = { fc_show_buoy, ft_buoy00 },
RedHex_30 = { fc_show_buoy, ft_buoy30 },
RedHex_04 = { fc_show_buoy, ft_buoy04 },
YelHex_00 = { fc_show_buoy, ft_buoy00 },
YelHex_30 = { fc_show_buoy, ft_buoy30 },
YelHex_04 = { fc_show_buoy, ft_buoy04 },
Repaired_00 = { fc_show_buoy, ft_buoy00 },
Repaired_30 = { fc_show_buoy, ft_buoy30 },
Repaired_04 = { fc_show_buoy, ft_buoy04 },
--
HexButton = { fc_show_map, ft_allhex },
RNetStarsButton = {fc_show_orrery,nil},
RNetNoStarsButton = {fc_hide_orrery,ft_allhex},
RNetCommButton = {fc_show_comm,nil},
RNetNoCommButton = {fc_show_nocomm,nil},
RNetFusionButton = {fc_show_fusion,nil},
RNetNoFusionButton = {fc_show_nofusion,nil},
RNetDriveButton = {fc_show_drive,nil},
RNetNoDriveButton = {fc_show_nodrive,nil},
ResurgenceReadyF = {fc_show_maplinks,nil},
-- links to other maps are implemented by the other addons
-- so have to monitor presence of those maps
-- NSSNFlag_f = {fc_show_other_mapt,ft_SuryaNayir},
-- NSLFlag_f = {fc_show_other_mapt,ft_Sola},
-- NSMFlag_f = {fc_show_other_mapt,ft_Mundilfoeri},
ReturnButtonF = {fc_show_maplinks,nil},
ToChartsButtonF = {fc_show_maplinks,nil},
}


-- ======================================= 
-- action function

fc_cmds = function (this_date)

-- don't do nuttin if died
  if (celestia:find("SoftwareFailure"):visible() )
  then
    fc_hide_tbl(ft_all)
    return
  end

fc_test_for_buttons()
fc_test_for_orrery()
fc_cycle_waves()
fc_cycle_init()

-- to implement commands only for the battery and its children
-- this code uses locals, fc_ routines and ft_ tables

  local sel = celestia:getselection()

  if (sel == fv_selP) then return 0 end
  
  local sname = sel:name()
  
-- get the two-element table (if any) matching the name of the selection

  local todo = ft_cmds[sname]
  
    if todo then 
     -- restore previous selection before executing this one
        if (fv_selP ~= nil) then celestia:select(fv_selP) end
	
	-- call the function [table element 1] associated with this command,
	-- passing it a single argument [table element 2]
	todo[1](todo[2])
	return 1
    end

-- This selection is not recognized as a command,
-- so save it for reversion after next command

	fv_selP = sel
	return 0
end
